{****************************************************************************}
{                            Data Master 2000                                }
{****************************************************************************}
unit B740;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  HPIBDev, Menus, ComCtrls, StdCtrls, Buttons, ExtCtrls;

type
  TB740Device = class(THPIBDevice)
    Panel: TPanel;
    DisplayStaticText: TStaticText;
    LabelStaticText: TStaticText;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    RangeLabel: TLabel;
    RangeTrackBar: TTrackBar;
    procedure RangeTrackBarChange(Sender: TObject);
    procedure SpeedButtonClick(Sender: TObject);
    procedure ClearItemClick(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
  private
    { Private declarations }
  protected
    { Protected declarations }
    function Get_Text: WideString; override; safecall;
    procedure Set_Text(const Value: WideString); override; safecall;
    procedure Set_Active(Value: WordBool); override; safecall;
  public
    { Public declarations }
  end;

implementation

uses ActiveX, AxCtrls, ComObj, ComServ, Devices_TLB;

{$R *.DFM}

/////// override standard behavior ///////

procedure TB740Device.ClearItemClick(Sender: TObject);
begin
  inherited;
  SpeedButton1.Down:=true; Set_Text('D0E');                // internal trigger
  with RangeTrackBar do begin Tag:=1; Position:=1; end;
end;

function TB740Device.Get_Text: WideString;
begin Result:=LabelStaticText.Caption+'='+DisplayStaticText.Caption; end;

procedure TB740Device.Set_Text(const Value: WideString);
var I: integer; S: shortstring;
begin
  S:=UpperCase(Value);
  if S[1]='F' then
  for I:=0 to ComponentCount-1 do
  if (Components[I] is TSpeedButton) and
     (IntToStr((Components[I] as TSpeedButton).Tag)=S[2]) then
  begin (Components[I] as TSpeedButton).Down:=true; Break; end;
  if S[1]='B' then
  begin
    I:=StrToInt(S[2]); if I=7 then I:=6;        // calculate trackbar position
    with RangeTrackBar do begin Tag:=I;{lock OnChange} Position:=I; end;
  end;
  inherited;
end;

procedure TB740Device.TimerTimer(Sender: TObject);
var S: shortstring;
begin
  Timer.Enabled:=false;
  S:=inherited Get_Text;              // note that INHERITED method is called!
  case S[1] of                                     // calculate & set LABEL...
    'R': LabelStaticText.Caption:='R     kOm';
    'U': LabelStaticText.Caption:='Udc V';
    'V': LabelStaticText.Caption:='Uac V';
    'I': LabelStaticText.Caption:='I     A';
  else LabelStaticText.Caption:='????';
  end;
  if S[2]='P' then MessageBeep($ffffffff);                        // overflow!
  DisplayStaticText.Caption:=Copy(S,3,9);                     // refine number
  inherited;
end;

procedure TB740Device.Set_Active(Value: WordBool);
var I: integer;
begin
  inherited;
  for I:=0 to ComponentCount-1 do
  if Components[I] is TControl
  then (Components[I] as TControl).Enabled:=Value;
end;

////// other methods ////////////////

procedure TB740Device.RangeTrackBarChange(Sender: TObject);
var S: string;
begin                                                      // set device range
{ NOTE!! this control calls THIS HANDLER twice per hit,
  so we have to buffer position in TAG }
  with RangeTrackBar do if Position=Tag then Exit else Tag:=Position;
  if RangeTrackBar.Position=6 then S:='7'
  else S:=char(byte('0')+RangeTrackBar.Position);
  Set_Text('B'+S+'E');
end;

procedure TB740Device.SpeedButtonClick(Sender: TObject);    // set device mode
var S: shortstring;
begin S:=IntToStr((Sender as TComponent).Tag); Set_Text('F'+S+'E'); end;

initialization
  TActiveFormFactory.Create(
    ComServer,
    TActiveFormControl,
    TB740Device,
    CLASS_B740X,
    1,
    '',
    OLEMISC_SIMPLEFRAME or OLEMISC_ACTSLIKELABEL,
    tmApartment);
end.
