{****************************************************************************}
{                            Data Master 2000                                }
{****************************************************************************}
unit E712;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, HPIBDev, ExtCtrls, Menus, StdCtrls, ComCtrls;

type
  TE712Device = class(THPIBDevice)
    Panel: TPanel;
    DisplayAStaticText: TStaticText;
    LabelAStaticText: TStaticText;
    DisplayBStaticText: TStaticText;
    LabelBStaticText: TStaticText;
    RangeTrackBar: TTrackBar;
    RangeLabel: TLabel;
    N2: TMenuItem;
    ModeMenu: TMenuItem;
    LDItem: TMenuItem;
    CDItem: TMenuItem;
    LRItem: TMenuItem;
    CGItem: TMenuItem;
    procedure TimerTimer(Sender: TObject);
    procedure ClearItemClick(Sender: TObject);
    procedure RangeTrackBarChange(Sender: TObject);
    procedure ModeMenuClick(Sender: TObject);
  private
    { Private declarations }
  protected
    { Protected declarations }
    function Get_Text: WideString; override; safecall;
    procedure Set_Text(const Value: WideString); override; safecall;
    procedure Set_Active(Value: WordBool); override; safecall;
  public
    { Public declarations }
  end;

implementation

uses ActiveX, AxCtrls, ComObj, ComServ, Devices_TLB;

{$R *.dfm}

{ TE712Device - override standard behavior}

function TE712Device.Get_Text: WideString;
begin
  Result:=LabelAStaticText.Caption+'='+DisplayAStaticText.Caption+#13#10+
  LabelBStaticText.Caption+'='+DisplayBStaticText.Caption;
end;

procedure TE712Device.Set_Active(Value: WordBool);     // exactly as in B7-40!
var I: integer;
begin
  inherited;
  for I:=0 to ComponentCount-1 do
  if Components[I] is TControl
  then (Components[I] as TControl).Enabled:=Value;
end;

procedure TE712Device.Set_Text(const Value: WideString);
var I: integer;
begin
  I:=StrToInt(Value);
  case I of
    0..3: ModeMenu.Items[I].Checked:=true;
    32: with RangeTrackBar do begin Tag:=5; Position:=5; end;
    42..46: with RangeTrackBar do begin Tag:=I-42; Position:=I-42; end;
  end;
  inherited;
end;

procedure TE712Device.TimerTimer(Sender: TObject);
var S: shortstring;
begin 
  Timer.Enabled:=false;
  inherited Set_Text('$38');
  S:=inherited Get_Text;
  DisplayAStaticText.Caption:=Copy(S,1,10);
  LabelAStaticText.Caption:=S[11];
  inherited Set_Text('$30');
  S:=inherited Get_Text;
  DisplayBStaticText.Caption:=Copy(S,1,10);
  LabelBStaticText.Caption:=S[11];
  inherited;
end;

procedure TE712Device.ClearItemClick(Sender: TObject);
begin
  inherited;                                       // initialize device and UI
  with RangeTrackBar do begin Tag:=2; Position:=2; end;{todo?: init MODE menu}
end;

/// other stuff 

procedure TE712Device.RangeTrackBarChange(Sender: TObject);
begin
  with RangeTrackBar do if Position=Tag then Exit else Tag:=Position;
  if RangeTrackBar.Position=5 then inherited Set_Text('$20') else
  inherited Set_Text(Format('$%2.2x',[RangeTrackBar.Position+42]));
end;

procedure TE712Device.ModeMenuClick(Sender: TObject);
begin
  inherited Set_Text(Format('$%2.2x',[(Sender as TMenuItem).Tag]));
end;

initialization
  TActiveFormFactory.Create(
    ComServer,
    TActiveFormControl,
    TE712Device,
    CLASS_E712X,
    3,
    '',
    OLEMISC_SIMPLEFRAME or OLEMISC_ACTSLIKELABEL,
    tmApartment);
end.
